﻿using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.UI;
using System.Collections;

public class MenuScript : MonoBehaviour
{

    public Canvas ExitCanvas;
	public Canvas NavigationPanel;
    public Canvas OptionsCanvas;
    public Button PlayButton;
    public Button ExitButton;
    public Button OptionButton;
    public Button ExitCanvasYes;
    public Button ExitCanvasNo;
    public Button BackButtonInOptions;
    public InputField LengthInputField;
    public Dropdown DificultyDropdown;
    public Text highScore;

    // Use this for initialization
    void Start()
    {
		NavigationPanel = NavigationPanel.GetComponent<Canvas> ();
        ExitCanvas = ExitCanvas.GetComponent<Canvas>();
        PlayButton = PlayButton.GetComponent<Button>();
        ExitButton = ExitButton.GetComponent<Button>();
        OptionButton = OptionButton.GetComponent<Button>();
        ExitCanvasNo = ExitCanvasNo.GetComponent<Button>();
        ExitCanvasYes = ExitCanvasYes.GetComponent<Button>();
        OptionsCanvas = OptionsCanvas.GetComponent<Canvas>();
        LengthInputField = LengthInputField.GetComponent<InputField>();
        DificultyDropdown = DificultyDropdown.GetComponent<Dropdown>();
        highScore.text = "High Score: " + OpenScore();
        OptionsCanvas.enabled = false;
        ExitCanvas.enabled = false;
    }

    public int OpenScore()
    {
        return PlayerPrefs.GetInt("Player");
    }

    public void BackButtonInOptionsPress()
    {
        OptionsCanvas.enabled = false;
		NavigationPanel.enabled = true;
        ExitCanvas.enabled = false;
        PlayButton.enabled = true;
        ExitButton.enabled = true;
        OptionButton.enabled = true;
    }

    public void OptionsButtonPress()
    {
        OptionsCanvas.enabled = true;
		NavigationPanel.enabled = false;
        PlayButton.enabled = false;
        ExitButton.enabled = false;
        OptionButton.enabled = false;
    }

    public void OnDifficultyChanged()
    {
        switch (DificultyDropdown.value)
        {
            case 0:
                Move.moveSpeed = 5;
                break;
            case 1:
                Move.moveSpeed = 10;
                break;
            case 2:
                Move.moveSpeed = 15;
                break;
        }
    }
    public void NoPress()
    {
		NavigationPanel.enabled = true;
        ExitCanvas.enabled = false;
        PlayButton.enabled = true;
        ExitButton.enabled = true;
        OptionButton.enabled = true;
    }

    public void TextChanged()
    {
        try
        {
            int value = int.Parse(LengthInputField.text);
            if (value < 120)
            {
                LengthInputField.text = "The Map Length should be atleat 120";
            }
            else
            {
                GenerationScript.MapSize = value;
            }
            
        }
        catch
        {
            GenerationScript.MapSize = 120;
        }
    }

    public void ExitPress()
    {
		NavigationPanel.enabled = false;
        ExitCanvas.enabled = true;
        PlayButton.enabled = false;
        ExitButton.enabled = false;
        OptionButton.enabled = false;
    }

    public void StartLevel()
    {
		Cursor.visible = false;
        SceneManager.LoadScene("Scene");
    }

    public void ExitGame()
    {
        Application.Quit();
    }
}
