﻿using UnityEngine;

public class Move : MonoBehaviour
{
    public static float moveSpeed = 5f;
    public float speed = 10f;
    private Vector3 mousePosition;
    UICameraScript UIscript;
    private int position;
    private bool _hasHistoricPoint;
    private Vector3 _historicPoint;
    private float FilterSmoothingFactor = 1f;
    void Start()
    {
        UIscript = Camera.main.GetComponent<UICameraScript>();
        this.transform.rotation = Quaternion.identity;
    }

    void FixedUpdate()
    {
        /* Ray ray = Camera.main.ScreenPointToRay(Input.mousePosition);
         if(Physics.Raycast(ray,out hit, rayCastLength))
         {
             print(hit.collider.name);
             if(hit.collider.name == "Background")
             {
                 Target.transform.position = hit.point;
             }
         }*/

        transform.position = new Vector3(transform.position.x + moveSpeed * Time.deltaTime, transform.position.y);
        //if(Input.mousePosition.y>Screen.)
        mousePosition = Input.mousePosition;
        
        //mousePosition = new Vector3(EyeTracking.GetGazePoint().Screen.x, EyeTracking.GetGazePoint().Screen.y, 0);
    
         mousePosition = Camera.main.ScreenToWorldPoint(Input.mousePosition);
        if (mousePosition.x > transform.position.x)
        {
            if ((mousePosition.x - transform.position.x) < 0.5f && (mousePosition.y - transform.position.y) < 0.5f)
            {
                transform.position = Vector2.Lerp(transform.position, mousePosition, 0.1f);
            }
            else
            {
                transform.position = Vector2.Lerp(transform.position, new Vector3(transform.position.x + 0.5f, mousePosition.y + 0.5f), 0.1f);
            }
        }
    }

    private Vector3 Smoothify(Vector3 point)
    {
        if (!_hasHistoricPoint)
        {
            _historicPoint = point;
            _hasHistoricPoint = true;
        }

        var smoothedPoint = new Vector3(
            point.x * (1.0f - FilterSmoothingFactor) + _historicPoint.x * FilterSmoothingFactor,
            point.y * (1.0f - FilterSmoothingFactor) + _historicPoint.y * FilterSmoothingFactor,
            point.z * (1.0f - FilterSmoothingFactor) + _historicPoint.z * FilterSmoothingFactor);

        _historicPoint = smoothedPoint;

        return smoothedPoint;
    }

    void OnCollisionEnter2D(Collision2D other)
    {
        gameObject.GetComponent<AudioSource>().Play();
        if (other.gameObject.name == "ObstacleDown Big(Clone)")
        {
            position = 1;
        }
        if (other.gameObject.name == "ObstacleUp Big")
        {
            position = 2;
        }
        if (other.gameObject.name == "ObstacleUp(Clone)" || other.gameObject.name == "ObstacleDown(Clone)" || other.gameObject.name == "Falling Obstacle 2" || other.gameObject.name == "Falling Obstacle 3")
        {
            position = 3;
        }
        if (other.gameObject.name.Substring(0, 6) == "Border")
        {
            position = 3;
        }
        Die(position);
    }
    public void Die(int pos)
    {
        UIscript.TakeLife();
        switch (position)
        {
            case 1:
                {
                    this.transform.position = new Vector3(this.transform.position.x, +3.35f, 0);
                    break;
                }
            case 2:
                {

                    this.transform.position = new Vector3(this.transform.position.x, -3.35f, 0);
                    break;
                }
            case 3:
                {
                    this.transform.position = new Vector3(this.transform.position.x, 0, 0);
                    break;
                }
        }
        this.transform.rotation = Quaternion.Euler(0, 0, Input.GetAxis("Mouse Y"));
    }
}
